diff -urN Original_4.4.4_r1/packages/apps/a1/Android.mk AndroidSource/packages/apps/a1/Android.mk
--- Original_4.4.4_r1/packages/apps/a1/Android.mk	1970-01-01 09:00:00.000000000 +0900
+++ AndroidSource/packages/apps/a1/Android.mk	2015-11-25 17:27:50.000000000 +0900
@@ -0,0 +1,18 @@
+LOCAL_PATH:= $(call my-dir)
+include $(CLEAR_VARS)
+
+LOCAL_MODULE_TAGS := optional
+
+LOCAL_SRC_FILES := $(call all-java-files-under, src)
+
+LOCAL_PACKAGE_NAME := a1 
+LOCAL_CERTIFICATE := platform
+LOCAL_PRIVILEGED_MODULE := true
+
+include $(BUILD_PACKAGE)
+
+include $(call all-makefiles-under, $(LOCAL_PATH))
+
+
+
+
diff -urN Original_4.4.4_r1/packages/apps/a1/.classpath AndroidSource/packages/apps/a1/.classpath
--- Original_4.4.4_r1/packages/apps/a1/.classpath	1970-01-01 09:00:00.000000000 +0900
+++ AndroidSource/packages/apps/a1/.classpath	2015-05-12 12:44:40.000000000 +0900
@@ -0,0 +1,9 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<classpath>
+	<classpathentry kind="src" path="src"/>
+	<classpathentry kind="src" path="gen"/>
+	<classpathentry kind="con" path="com.android.ide.eclipse.adt.ANDROID_FRAMEWORK"/>
+	<classpathentry exported="true" kind="con" path="com.android.ide.eclipse.adt.LIBRARIES"/>
+	<classpathentry exported="true" kind="con" path="com.android.ide.eclipse.adt.DEPENDENCIES"/>
+	<classpathentry kind="output" path="bin/classes"/>
+</classpath>
diff -urN Original_4.4.4_r1/packages/apps/a1/.project AndroidSource/packages/apps/a1/.project
--- Original_4.4.4_r1/packages/apps/a1/.project	1970-01-01 09:00:00.000000000 +0900
+++ AndroidSource/packages/apps/a1/.project	2015-05-12 12:44:38.000000000 +0900
@@ -0,0 +1,33 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<projectDescription>
+	<name>a1</name>
+	<comment></comment>
+	<projects>
+	</projects>
+	<buildSpec>
+		<buildCommand>
+			<name>com.android.ide.eclipse.adt.ResourceManagerBuilder</name>
+			<arguments>
+			</arguments>
+		</buildCommand>
+		<buildCommand>
+			<name>com.android.ide.eclipse.adt.PreCompilerBuilder</name>
+			<arguments>
+			</arguments>
+		</buildCommand>
+		<buildCommand>
+			<name>org.eclipse.jdt.core.javabuilder</name>
+			<arguments>
+			</arguments>
+		</buildCommand>
+		<buildCommand>
+			<name>com.android.ide.eclipse.adt.ApkBuilder</name>
+			<arguments>
+			</arguments>
+		</buildCommand>
+	</buildSpec>
+	<natures>
+		<nature>com.android.ide.eclipse.adt.AndroidNature</nature>
+		<nature>org.eclipse.jdt.core.javanature</nature>
+	</natures>
+</projectDescription>
diff -urN Original_4.4.4_r1/packages/apps/a1/res/layout/activity_main.xml~ AndroidSource/packages/apps/a1/res/layout/activity_main.xml~
--- Original_4.4.4_r1/packages/apps/a1/res/layout/activity_main.xml~	1970-01-01 09:00:00.000000000 +0900
+++ AndroidSource/packages/apps/a1/res/layout/activity_main.xml~	2015-05-12 16:37:16.000000000 +0900
@@ -0,0 +1,29 @@
+<RelativeLayout xmlns:android="http://schemas.android.com/apk/res/android"
+    xmlns:tools="http://schemas.android.com/tools"
+    android:layout_width="match_parent"
+    android:layout_height="match_parent"
+    android:paddingBottom="@dimen/activity_vertical_margin"
+    android:paddingLeft="@dimen/activity_horizontal_margin"
+    android:paddingRight="@dimen/activity_horizontal_margin"
+    android:paddingTop="@dimen/activity_vertical_margin"
+    tools:context="com.example.aa.MainActivity" >
+
+    
+    
+    <TextView
+        android:id="@+id/textView1"
+        android:layout_width="wrap_content"
+        android:layout_height="wrap_content"
+        android:text="@string/hello_world" />
+
+    <Button
+        android:id="@+id/button1"
+        android:layout_width="wrap_content"
+        android:layout_height="wrap_content"
+        android:layout_alignLeft="@+id/textView1"
+        android:layout_below="@+id/textView1"
+        android:layout_marginLeft="38dp"
+        android:layout_marginTop="20dp"
+        android:text="Client" />
+
+</RelativeLayout>
\ No newline at end of file
diff -urN Original_4.4.4_r1/packages/apps/Settings/.classpath AndroidSource/packages/apps/Settings/.classpath
--- Original_4.4.4_r1/packages/apps/Settings/.classpath	1970-01-01 09:00:00.000000000 +0900
+++ AndroidSource/packages/apps/Settings/.classpath	2016-02-15 13:32:52.000000000 +0900
@@ -0,0 +1,8 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<classpath>
+	<classpathentry kind="src" path="src"/>
+	<classpathentry kind="src" path="tests/src"/>
+	<classpathentry kind="con" path="org.eclipse.jdt.launching.JRE_CONTAINER"/>
+	<classpathentry kind="src" path="/AndroidSource"/>
+	<classpathentry kind="output" path="bin"/>
+</classpath>
diff -urN Original_4.4.4_r1/packages/apps/Settings/.gitignore AndroidSource/packages/apps/Settings/.gitignore
--- Original_4.4.4_r1/packages/apps/Settings/.gitignore	1970-01-01 09:00:00.000000000 +0900
+++ AndroidSource/packages/apps/Settings/.gitignore	2016-02-15 18:34:09.000000000 +0900
@@ -0,0 +1 @@
+/bin/
diff -urN Original_4.4.4_r1/packages/apps/Settings/.project AndroidSource/packages/apps/Settings/.project
--- Original_4.4.4_r1/packages/apps/Settings/.project	1970-01-01 09:00:00.000000000 +0900
+++ AndroidSource/packages/apps/Settings/.project	2016-02-15 13:10:41.000000000 +0900
@@ -0,0 +1,17 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<projectDescription>
+	<name>Settings</name>
+	<comment></comment>
+	<projects>
+	</projects>
+	<buildSpec>
+		<buildCommand>
+			<name>org.eclipse.jdt.core.javabuilder</name>
+			<arguments>
+			</arguments>
+		</buildCommand>
+	</buildSpec>
+	<natures>
+		<nature>org.eclipse.jdt.core.javanature</nature>
+	</natures>
+</projectDescription>
diff -urN Original_4.4.4_r1/packages/apps/Settings/src/com/android/settings/collaboroid/CollaboRoidConfigUiBase.java AndroidSource/packages/apps/Settings/src/com/android/settings/collaboroid/CollaboRoidConfigUiBase.java
--- Original_4.4.4_r1/packages/apps/Settings/src/com/android/settings/collaboroid/CollaboRoidConfigUiBase.java	1970-01-01 09:00:00.000000000 +0900
+++ AndroidSource/packages/apps/Settings/src/com/android/settings/collaboroid/CollaboRoidConfigUiBase.java	2016-01-06 10:20:03.000000000 +0900
@@ -0,0 +1,41 @@
+/*
+ * Copyright (C) 2010 The Android Open Source Project
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *      http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS,
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+
+package com.android.settings.collaboroid;
+
+import android.content.Context;
+import android.view.LayoutInflater;
+import android.widget.Button;
+
+/**
+ * Foundation interface glues between Activities and UIs like
+ * {@link WifiDialog} or {@link WifiConfigUiForSetupWizardXL}.
+ */
+public interface CollaboRoidConfigUiBase {
+    public Context getContext();
+    public LayoutInflater getLayoutInflater();
+    public boolean isEdit();
+
+    public void setTitle(int id);
+    public void setTitle(CharSequence title);
+
+    public void setSubmitButton(CharSequence text);
+    public void setForgetButton(CharSequence text);
+    public void setCancelButton(CharSequence text);
+    public Button getSubmitButton();
+    public Button getForgetButton();
+    public Button getCancelButton();
+}
\ No newline at end of file
diff -urN Original_4.4.4_r1/packages/apps/Settings/src/com/android/settings/collaboroid/CollaboRoidDialog.java AndroidSource/packages/apps/Settings/src/com/android/settings/collaboroid/CollaboRoidDialog.java
--- Original_4.4.4_r1/packages/apps/Settings/src/com/android/settings/collaboroid/CollaboRoidDialog.java	1970-01-01 09:00:00.000000000 +0900
+++ AndroidSource/packages/apps/Settings/src/com/android/settings/collaboroid/CollaboRoidDialog.java	2016-06-23 18:53:02.000000000 +0900
@@ -0,0 +1,218 @@
+/*
+ * Copyright (C) 2010 The Android Open Source Project
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *      http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS,
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+
+package com.android.settings.collaboroid;
+
+import java.util.HashMap;
+
+import com.android.settings.R;
+
+import android.app.AlertDialog;
+import android.content.Context;
+import android.content.DialogInterface;
+import android.os.Bundle;
+import android.service.devicemanager.Device;
+import android.util.Log;
+import android.view.View;
+import android.view.ViewGroup;
+import android.widget.Button;
+import android.widget.CheckBox;
+import android.widget.CompoundButton;
+import android.widget.CompoundButton.OnCheckedChangeListener;
+import android.widget.TextView;
+
+class CollaboRoidDialog extends AlertDialog implements CollaboRoidConfigUiBase {
+	private static final String TAG = "CollaboRoidDialog";
+	
+    static final int BUTTON_SUBMIT = DialogInterface.BUTTON_POSITIVE;
+    static final int BUTTON_FORGET = DialogInterface.BUTTON_NEUTRAL;
+
+    private final boolean mEdit;
+    private final DialogInterface.OnClickListener mListener;
+    private final RemoteDevice mRemoteDevice;
+    
+    private HashMap<String, Boolean> askedResources = new HashMap<String, Boolean>();
+    private HashMap<String, Boolean> allowedResources = new HashMap<String, Boolean>();
+    
+    private CheckBox[] resourceCheckBoxes = new CheckBox[Device.RESOURCE_TYPE_SIZE];
+    private int[][] resources = new int[2][Device.RESOURCE_TYPE_SIZE];
+
+    private View mView;
+    //private WifiConfigController mController;
+
+    public CollaboRoidDialog(Context context, DialogInterface.OnClickListener listener,
+            RemoteDevice remoteDevice, boolean edit) {
+        super(context);
+        mEdit = edit;
+        mListener = listener;
+        mRemoteDevice = remoteDevice;
+    }
+    
+    public CollaboRoidDialog(Context context, DialogInterface.OnClickListener listener,
+            RemoteDevice remoteDevice) {
+        super(context);
+        mEdit = false;
+        mListener = listener;
+        mRemoteDevice = remoteDevice;
+    }
+
+    /*@Override
+    public WifiConfigController getController() {
+        return mController;
+    }*/
+
+    @Override
+    protected void onCreate(Bundle savedInstanceState) 
+    {
+        //mView = getLayoutInflater().inflate(R.layout.collaboroid_dialog, null);
+    	mView = getLayoutInflater().inflate(R.layout.collaboroid_dialog, null);
+        setView(mView);
+        setInverseBackgroundForced(true);
+        //mController = new WifiConfigController(this, mView, mRemoteDevice, mEdit);
+        super.onCreate(savedInstanceState);
+        
+        ViewGroup group = (ViewGroup) mView.findViewById(R.id.info);
+        
+        Log.d(TAG, mRemoteDevice.name + "  -  " + mRemoteDevice.description);
+        
+        for(int resource : mRemoteDevice.resources)
+        	addRow(group, resource, mRemoteDevice.askedResources[resource]==1, mRemoteDevice.allowedResources[resource]==1);
+    }
+    
+    private void addRow(ViewGroup group, int resource, Boolean isAsked, Boolean isAllowed) 
+    {
+        View row = this.getLayoutInflater().inflate(R.layout.collaboroid_dialog_row, group, false);
+        
+        ((TextView) row.findViewById(R.id.name)).setText(Device.ResourceNames[resource]);
+        
+    	CheckBox cb = (CheckBox) row.findViewById(R.id.checkbox_ask); 
+    	cb.setChecked(isAsked);
+    	cb.setTag(resource);
+    	cb.setOnCheckedChangeListener(new OnCheckedChangeListener()
+		{
+			@Override
+			public void onCheckedChanged(CompoundButton buttonView, boolean isChecked)
+			{
+				// TODO Auto-generated method stub
+				String msg = buttonView.getText().toString();
+				
+				askedResources.put(msg, isChecked);
+				
+				resources[0][Integer.parseInt(buttonView.getTag().toString())] = isChecked?1:0;
+				
+				Log.d(TAG, buttonView.getTag() + " - " + isChecked);
+			}
+		});
+    	resourceCheckBoxes[resource] = cb;
+    	
+    	/*CheckBox cb2 = (CheckBox) row.findViewById(R.id.checkbox_allow); 
+    	cb2.setChecked(isAllowed);
+    	cb2.setTag(resource);
+    	cb2.setOnCheckedChangeListener(new OnCheckedChangeListener()
+		{
+			@Override
+			public void onCheckedChanged(CompoundButton buttonView, boolean isChecked)
+			{
+				// TODO Auto-generated method stub
+				
+				String msg = buttonView.getText().toString();
+				
+				allowedResources.put(msg, isChecked);
+				
+				resources[1][Integer.parseInt(buttonView.getTag().toString())] = isChecked?1:0;
+				
+				Log.d(TAG, buttonView.getTag() + " - " + isChecked);
+			}
+		});*/
+    	
+    	group.addView(row);
+    	
+    	askedResources.put(Device.ResourceNames[resource], true);
+        //allowedResources.put(Device.ResourceNames[resource], true);
+    }
+    
+    public int[] getAskedResources()
+    {
+    	for(int i=0; i<Device.RESOURCE_TYPE_SIZE; i++)
+    		resources[0][i] = resourceCheckBoxes[i].isChecked()? 1:0;
+    	
+    	return resources[0];
+    }
+    
+    public int[] getAllowedResources()
+    {
+    	return resources[1];
+    }
+    
+        
+    public int getIntFromString(String resource)
+    {
+    	int id = -1;
+    	
+    	if(resource.equalsIgnoreCase("touch"))
+    		id = Device.RESOURCE_TYPE_TOUCH;
+    	else if(resource.equalsIgnoreCase("key"))
+    		id = Device.RESOURCE_TYPE_KEY;
+    	else if(resource.equalsIgnoreCase("location"))
+    		id = Device.RESOURCE_TYPE_LOCATION;
+    	else if(resource.equalsIgnoreCase("sensor"))
+    		id = Device.RESOURCE_TYPE_SENSOR;
+    	else if(resource.equalsIgnoreCase("vibrator"))
+    		id = Device.RESOURCE_TYPE_VIBRATOR;
+    	else if(resource.equalsIgnoreCase("video"))
+    		id = Device.RESOURCE_TYPE_VIDEO;
+    	else if(resource.equalsIgnoreCase("audio"))
+    		id = Device.RESOURCE_TYPE_AUDIO;
+    	
+    	
+    	return id;
+    }
+
+    @Override
+    public boolean isEdit() {
+        return mEdit;
+    }
+
+    @Override
+    public Button getSubmitButton() {
+        return getButton(BUTTON_SUBMIT);
+    }
+
+    @Override
+    public Button getForgetButton() {
+        return getButton(BUTTON_FORGET);
+    }
+
+    @Override
+    public Button getCancelButton() {
+        return getButton(BUTTON_NEGATIVE);
+    }
+
+    @Override
+    public void setSubmitButton(CharSequence text) {
+        setButton(BUTTON_SUBMIT, text, mListener);
+    }
+
+    @Override
+    public void setForgetButton(CharSequence text) {
+        setButton(BUTTON_FORGET, text, mListener);
+    }
+
+    @Override
+    public void setCancelButton(CharSequence text) {
+        setButton(BUTTON_NEGATIVE, text, mListener);
+    }
+}
diff -urN Original_4.4.4_r1/packages/apps/Settings/src/com/android/settings/collaboroid/CollaboRoidEnabler.java AndroidSource/packages/apps/Settings/src/com/android/settings/collaboroid/CollaboRoidEnabler.java
--- Original_4.4.4_r1/packages/apps/Settings/src/com/android/settings/collaboroid/CollaboRoidEnabler.java	1970-01-01 09:00:00.000000000 +0900
+++ AndroidSource/packages/apps/Settings/src/com/android/settings/collaboroid/CollaboRoidEnabler.java	2016-06-23 16:39:31.000000000 +0900
@@ -0,0 +1,126 @@
+/*
+ * Copyright (C) 2010 The Android Open Source Project
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *      http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS,
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+
+package com.android.settings.collaboroid;
+
+import android.content.BroadcastReceiver;
+import android.content.Context;
+import android.content.Intent;
+import android.content.IntentFilter;
+import android.net.wifi.WifiManager;
+import android.provider.Settings;
+import android.service.collaboroid.CollaboRoidManager;
+import android.util.Log;
+import android.widget.CompoundButton;
+import android.widget.Switch;
+
+public class CollaboRoidEnabler implements CompoundButton.OnCheckedChangeListener  {
+	private static final String TAG = "CollaboRoidEnabler";
+	
+	private final Context mContext;
+    private Switch mSwitch;
+    //private AtomicBoolean mConnected = new AtomicBoolean(false);
+
+    private final IntentFilter mIntentFilter;
+    private final BroadcastReceiver mReceiver = new BroadcastReceiver() {
+		@Override
+		public void onReceive(Context context, Intent intent) {
+			// TODO Auto-generated method stub
+			String action = intent.getAction();
+			
+			if(CollaboRoidManager.COLLABOROID_STATE_CHANGED_ACTION.equals(action))
+			{
+				handleStateChanged(intent.getIntExtra(CollaboRoidManager.EXTRA_COLLABOROID_STATE, 
+						CollaboRoidManager.COLLABOROID_STATE_UNKNOWN));
+			}
+		}
+	};
+    
+    public CollaboRoidEnabler(Context context, Switch switch_) {
+        mContext = context;
+        mSwitch = switch_;
+        
+        mIntentFilter = new IntentFilter(CollaboRoidManager.COLLABOROID_STATE_CHANGED_ACTION);
+    }
+
+    public void resume() {
+        // Wi-Fi state is sticky, so just let the receiver update UI
+        mContext.registerReceiver(mReceiver, mIntentFilter);
+    	mSwitch.setOnCheckedChangeListener(this);
+    }
+
+    public void pause() {
+    	mContext.unregisterReceiver(mReceiver);
+        mSwitch.setOnCheckedChangeListener(null);
+    }
+
+    public void setSwitch(Switch switch_) {
+        if (mSwitch == switch_) return;
+        mSwitch.setOnCheckedChangeListener(null);
+        mSwitch = switch_;
+        mSwitch.setOnCheckedChangeListener(this);
+
+        boolean isEnabled = false;
+        if(Settings.Global.getInt(mContext.getContentResolver(), "collaboroid_on",3) == 1)
+        	isEnabled = true;
+    	else
+    		isEnabled = false;
+        
+        Log.d(TAG, isEnabled + "");
+        mSwitch.setChecked(isEnabled);
+    }
+
+    public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
+    	
+    	CollaboRoidManager mCollaboRoidManager = (CollaboRoidManager) mContext.getSystemService(Context.COLLABOROID);
+    	Log.d(TAG, isChecked+"");
+		mCollaboRoidManager.setCollaboRoidEnabled(isChecked);
+		
+/*		if(isChecked)
+			updateRemoteDevices();
+		else
+			getPreferenceScreen().removeAll();*/
+    }
+
+    private void handleStateChanged(int state) {
+        switch (state) {
+            case CollaboRoidManager.COLLABOROID_STATE_ENABLING:
+                mSwitch.setEnabled(false);
+                break;
+            case CollaboRoidManager.COLLABOROID_STATE_ENABLED:
+                setSwitchChecked(true);
+                mSwitch.setEnabled(true);
+                break;
+            case CollaboRoidManager.COLLABOROID_STATE_DISABLING:
+                mSwitch.setEnabled(false);
+                break;
+            case CollaboRoidManager.COLLABOROID_STATE_DISABLED:
+                setSwitchChecked(false);
+                mSwitch.setEnabled(true);
+                break;
+            default:
+                setSwitchChecked(false);
+                mSwitch.setEnabled(true);
+                break;
+        }
+    }
+
+    private void setSwitchChecked(boolean checked) {
+        if (checked != mSwitch.isChecked()) {
+            mSwitch.setChecked(checked);
+        }
+    }
+}
